unit flujoraw;

interface

uses
  Classes, SysUtils,
  xMatDefs,
  urawdata,
  usistema, uactoresflucar,
  uConstantesSimSEE,
  AlgebraC, ucpxresolvecuacs, MatCPX, Math, matreal,
  //Dialogs,
  uauxiliares;

procedure LeerRaw(sala: TSalaFlucar; archi: string);
procedure EscribirRaw(sala: TSalaFlucar; archi: string);
procedure Preparar_sistema(sala: TSalaFlucar);
procedure Cargar_problema(sala: TSalaFlucar);
procedure Cargar_solo_problema(sala: TSalaFlucar);
procedure Cargar_datos_luego_de_resuelto(Convergio: boolean; sala: TSalaFlucar);
procedure cargar_taps(sala: TSalaFlucar);

procedure cargar_tap_winding(winding: Integer; ata:TRaw_transformerAdjust;
  var j:Integer; sala:TSalaFlucar);

function RevisarSala(sala: TSalaFlucar):Boolean;

function conectividad(var MatAdmitancias: TMatrizDeAdmitancias;
  var lugar: integer): boolean;

implementation

uses
  ufunciones_flucar;

procedure LeeRraw(sala: TSalaFlucar; archi: string);

var

  k: integer;
  f: textfile;
  modulo: double;
  carga: TRaw_Load;
  generador: TRaw_Generator;
  linea: TRaw_Branch;
  linea_Imp_cero: TRaw_Branch_Impedancia_cero;
  trafoAdjust: TRaw_TransformerAdjust;
  area: TRaw_AreaInterchange;
  termDC2vias: TRaw_TwoTerminal_DCLine;
  Fixedshunt: TRaw_FixedShunt;
  shunt: TRaw_SwitcheShunt;
  ICTable: TRaw_TransformerImpedanceCorrectionTables;
  MultiDC: TRaw_MultiTerminal_DCLine;
  Multilinea: TRaw_MultiSectionLineGrouping;
  zona: TRaw_Zone;
  trasarea: TRaw_InterAreaTransfer;
  dueno: TRaw_Owner;
  fact: TRaw_Facts;
  r: string;
  vsc: TRaw_VoltageSourceConverter_DCLine;
  caso: TRaw_CaseIdentification;

begin
  uauxiliares.setSeparadoresGlobales;

  k := pos('.', archi);
  NOmbreArch := copy(archi, 1, k - 1);
  extensionent := '.raw';
  //extensionsal:='.sal';
  NombreArchent := NombreArch + extensionent;
  //NombreArchsal:=NombreArch+extensionsal;

  Assign(f, NombreArchent);
        {$I-}
  Reset(f);
        {$I+}
  if ioresult <> 0 then
  begin
    // si falló, intento buscar el archivo en la ruta local.
    r := extractFileName(NombreArchEnt);
    Assign(f, r);
          {$I-}
    Reset(f);
          {$I+}
    if ioresult <> 0 then
      raise Exception.Create(' Error abriendo archivo ' + NombreArchent);
  end;
  // 1 Se lee el descriptor del caso

  caso := TRaw_CaseIdentification.LoadFromtext(sala, f);
  sala.caso.Add(caso);
  sala.actores.Add(caso);

  writeln;
  writeln(caso.ic);
  writeln(caso.sbase);
  writeln(caso.ds1);
  writeln(caso.ds2);
  writeln;

  // 2 Se leen las barras
  leer_barras_raw(sala, f);

  // 3 Se leen las cargas
  carga := TRaw_Load.loadfromtext(sala, f);
  while carga.I <> 0 do
  begin
    if carga.STATUS<>0 then
    begin
      //writeln(CARGA.I, ' ' + #9, carga.PL: 1: 2, ' ' + #9, carga.QL: 1: 2);
      sala.Cargas.add(carga);
      sala.actores.add(carga);
    end;
    carga := TRaw_Load.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las CARGAS: ', sala.cargas.Count);
  carga.Free;

  // 4 si es la version 32 leo los Fixed Shunts
  if RAW_VER >= 32 then
  begin
    Fixedshunt := TRaw_FixedShunt.loadfromtext(sala, f);
    while Fixedshunt.I <> 0 do
    begin
      if Fixedshunt.STATUS<>0 then
      begin
        //writeln(Fixedshunt.I);
        sala.ShuntsFijos.add(Fixedshunt);
        sala.actores.add(FixedShunt);
      end;
      Fixedshunt := TRaw_FixedShunt.loadfromtext(sala, f);
    end;
    writeln;
    writeln('ESTO es el fin de las FIXED SHUNTS: ', sala.shuntsfijos.Count);
    Fixedshunt.Free;
  end;

  // 5 Se leen los generadores
  generador := TRaw_Generator.loadfromtext(sala, f);
  while generador.I <> 0 do
  begin
    if generador.STAT<>0 then
    begin
      writeln('Generador: ', generador.I);
      sala.Generadores.add(generador);
      sala.actores.add(generador);
    end;
    generador := TRaw_Generator.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las GENERADORES: ', sala.Generadores.Count);
  generador.Free;

  // 6 Se leen las lineas
  linea := TRaw_Branch.loadfromtext(sala, f);
  while linea.I <> 0 do
  begin
    if linea.ST = 1 then
    begin
      writeln('Linea: ', linea.I, ' ' + #9, linea.J);
      modulo := mod1(numc(linea.RR, linea.X)^);
      if modulo > 1.01E-4 then
      begin
        linea.resolver_referencias;
        linea.IMP_Zero := False;
        sala.lineas.add(linea);
        sala.actores.add(linea);
      end
      else
      begin
        linea.resolver_referencias;
        //linea.Barra_J.IMP_CERO:=True;
        linea.IMP_Zero := True;
        if not (linea.Barra_I.IMP_CERO) and (linea.Barra_J.IMP_CERO) then
        begin
          linea.Barra_I.PrincipalLinImpCero := True;
          linea.Barra_J.BarraExtImpCero := linea.Barra_I.I;
          linea.Barra_J.IMP_CERO := True;
          //linea.Barra_J:=linea.Barra_I;
        end;
        if (linea.Barra_I.IMP_CERO) and not (linea.Barra_J.IMP_CERO) then
        begin
          linea.Barra_J.PrincipalLinImpCero := True;
          linea.Barra_I.BarraExtImpCero := linea.Barra_J.I;
          linea.Barra_I.IMP_CERO := True;
          //linea.Barra_I:=linea.Barra_J;
        end;
        if not (linea.Barra_I.IMP_CERO) and not (linea.Barra_J.IMP_CERO) then
        begin
          if (linea.Barra_I=linea.Barra_J) then
          begin
            linea := TRaw_Branch.loadfromtext(sala, f);
            writeln('Linea de impedancia Cero entre la misma Barra Principal');
            Continue;  //Hay que resolver cuando la linea tiene impedancia cero y esta conectada a la misma barra
          end;
          if linea.Barra_I.PrincipalLinImpCero then
          begin
            linea.Barra_J.BarraExtImpCero := linea.Barra_I.I;
            linea.Barra_J.IMP_CERO := True;
            //linea.Barra_J:=linea.Barra_I;
          end
          else
          if linea.Barra_J.PrincipalLinImpCero then
          begin
            linea.Barra_I.BarraExtImpCero := linea.Barra_J.I;
            linea.Barra_I.IMP_CERO := True;
            //linea.Barra_I:=linea.Barra_J;
          end
          else
          begin
            linea.Barra_I.PrincipalLinImpCero := True;
            linea.Barra_J.BarraExtImpCero := linea.Barra_I.I;
            linea.Barra_J.IMP_CERO := True;
            //linea.Barra_J:=linea.Barra_I;
          end;

        end;
        if linea.Barra_I.IMP_CERO and linea.Barra_J.IMP_CERO then
        begin
          linea.Barra_I.PrincipalLinImpCero := True;
          linea.Barra_J.BarraExtImpCero := linea.Barra_I.BarraExtImpCero;
          linea.Barra_J.IMP_CERO := True;
          //linea.Barra_J:=linea.Barra_I;
        end;
        linea.resolver_referencias;
        sala.LineasImpCero.add(linea);
        sala.actores.add(linea);
      end;
    end;
    linea := TRaw_Branch.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las LINEAS: '+ IntToStr( sala.Lineas.Count) );
  linea.Free;

  // 7 Se leen los transformadores
  trafoAdjust := TRaw_TransformerAdjust.loadfromtext(sala, f);
  while trafoAdjust.I <> 0 do
  begin
    if trafoAdjust.STAT = 1 then
    begin
      // GFlieller@2019-08-01: Agrego el trafo de 3 arrollamientos
      if trafoAdjust.K = 0 then
        writeln(' Trafo: ', trafoAdjust.I, ' ' + #9, trafoAdjust.J)
      else
        writeln(' Trafo: ', trafoAdjust.I, ' ' + #9, trafoAdjust.J,' ' + #9, trafoAdjust.K);
      trafoAdjust.resolver_referencias;
      sala.trafosAdjust.add(trafoAdjust);
      sala.actores.add(trafoAdjust);
    end;
    trafoAdjust := TRaw_TransformerAdjust.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las TRAFOS: ', sala.trafosadjust.Count);
  writeln;
  trafoAdjust.Free;

  // 8 Se leen los areas
  area := TRaw_AreaInterchange.loadfromtext(sala, f);
  while area.I <> 0 do
  begin
    writeln('Area: ', area.I, ' ' + #9, area.ARNAME);
    sala.areas.add(area);
    sala.actores.Add(area);
    area := TRaw_AreaInterchange.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las AREAS');
  area.Free;


  // 9 Se leen las terminales DC de 2 vias
  termDC2vias := TRaw_TwoTerminal_DCLine.loadfromtext(sala, f);
  while termDC2vias.IDC_LineNumber <> 0 do
  begin
    if termDC2vias.MDC<>0 then
    begin
      writeln('Terminal DC: ', termDC2vias.IDC_LineNumber);
      termDC2vias.resolver_referencias;
      sala.TerminalesDC.add(termDC2vias);
      sala.actores.add(termDC2vias);
    end;
    termDC2vias := TRaw_TwoTerminal_DCLine.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de los terminales DC de 2 vias: ', sala.TerminalesDC.Count);
  termDC2vias.Free;

  // 10 Se leen los VSC. En la 26 se leen los switched shunts
  if RAW_VER < 32 then
  begin
    shunt := TRaw_SwitcheShunt.loadfromtext(sala, f);
    while shunt.I <> 0 do
    begin
      writeln('Shunt: ', shunt.I);
      sala.Shunts.add(shunt);
      sala.actores.add(shunt);
      shunt := TRaw_SwitcheShunt.loadfromtext(sala, f);
    end;
    writeln;
    writeln('ESTO es el fin de las SHUNTS: ', sala.Shunts.Count);
    shunt.Free;
  end
  else
  begin
    vsc := TRaw_VoltageSourceConverter_DCLine.loadfromtext(sala, f);
    while vsc.I <> 0 do
    begin
      if vsc.MDC<>0 then
      begin
        writeln('Voltage Source Converter: ', vsc.I);
        sala.VSC.add(vsc);
        sala.actores.add(vsc);
      end;
      vsc := TRaw_VoltageSourceConverter_DCLine.loadfromtext(sala, f);
    end;
    writeln;
    writeln('ESTO es el fin de las VSC: ', sala.VSC.Count);
    vsc.Free;
  end;


  //11 Se leen las tablas de correccion de las impedancias de los TRAFOS
  ICTable := TRaw_TransformerImpedanceCorrectionTables.loadfromtext(sala, f);
  while ICTable.I <> 0 do
  begin
    writeln('ICTable: ', ICTable.I);
    sala.ICTRATables.add(ICTable);
    sala.actores.add(ICTable);
    ICTable := TRaw_TransformerImpedanceCorrectionTables.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las tablas de correccion de las impedancias de los TRAFOS');
  ICTable.Free;


  //12 Se leen las terminales DC de multiples vias
  MultiDC := TRaw_MultiTerminal_DCLine.loadfromtext(sala, f);
  while MultiDC.I <> 0 do
  begin
    if MultiDC.MDC<>0 then
    begin
      writeln('Terminal MultiDC: ', MultiDC.I);
      sala.TerminalesDCMult.add(MultiDC);
      sala.actores.Add(MultiDC);
    end;
    MultiDC := TRaw_MultiTerminal_DCLine.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las terminales DC de multiples vias');
  MultiDC.Free;

  //13 Se leen las lineas agrupadas por seccion
  Multilinea := TRaw_MultiSectionLineGrouping.loadfromtext(sala, f);
  while Multilinea.I <> 0 do
  begin
    writeln('MultiLinea: ', Multilinea.I);
    sala.LineasSeccion.add(multiLinea);
    sala.actores.Add(multiLinea);
    Multilinea := TRaw_MultiSectionLineGrouping.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las lineas agrupadas por seccion');
  Multilinea.Free;

  //14 Se leen las zonas
  zona := TRaw_Zone.loadfromtext(sala, f);
  while zona.I <> 0 do
  begin
    writeln('Zona: ', zona.I, ' ', zona.ZONAME);
    sala.zonas.add(zona);
    sala.actores.Add(zona);
    zona := TRaw_Zone.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las ZONAS');
  zona.Free;

  //15 Se leen los datos de transferencia entre areas
  trasarea := TRaw_InterAreaTransfer.loadfromtext(sala, f);
  while trasarea.ARFROM <> 0 do
  begin
    writeln('Transferencia entre áreas: ', trasarea.ARFROM);
    sala.transfareas.add(trasArea);
    sala.actores.Add(trasArea);
    trasarea := TRaw_InterAreaTransfer.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de las transferencia entre AREAS');
  trasarea.Free;

  //16 Se leen los owners
  dueno := TRaw_Owner.loadfromtext(sala, f);
  while dueno.I <> 0 do
  begin
    //writeln(dueno.I);
    sala.owners.add(dueno);
    sala.actores.Add(dueno);
    dueno := TRaw_Owner.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de los OWNERS:', sala.owners.Count);
  dueno.Free;

  //17 Se leen los datos de control de los FACTS
  fact := TRaw_Facts.loadfromtext(sala, f);
  while fact.N <> 0 do
  begin
    if fact.MODE<>0 then
    begin
      sala.Facts.add(fact);
      sala.actores.Add(fact);
    end;
    fact := TRaw_Facts.loadfromtext(sala, f);
  end;
  writeln;
  writeln('ESTO es el fin de los FACTS');
  fact.Free;

  if RAW_VER >= 32 then
  begin
    shunt := TRaw_SwitcheShunt.loadfromtext(sala, f);
    while shunt.I <> 0 do
    begin
      if shunt.STAT<>0 then
      begin
        //writeln(shunt.I);
        sala.Shunts.add(shunt);
        sala.actores.Add(shunt);

      end;
      shunt := TRaw_SwitcheShunt.loadfromtext(sala, f);
    end;
    writeln;
    writeln('ESTO es el fin de las SHUNTS: ', sala.shunts.Count);
    shunt.Free;
  end;

  //writeln;   writeln('ESTO EL FIN DE LECTURA DE FLUJOS RAW');
  Close(f);
  sala.resolver_referencias;

  uauxiliares.setSeparadoresLocales;
end;

procedure cargar_tap_winding(winding: Integer; ata:TRaw_transformerAdjust;
  var j:Integer; sala:TSalaFlucar);
var
  NRegulador, NRegulado, windingCOD: integer;
  Barra_REGULADOR, Barra_REGULADA : TBarra;
  windingCONT: LongInt;
begin
  case winding of
  1:
    begin
      windingCOD:=ata.COD1;
      windingCONT:=ata.CONT1;
    end;
  2:
    begin
      windingCOD:=ata.COD2;
      windingCONT:=StrToInt(ata.CONT2);
    end;
  3:
    begin
      windingCOD:=ata.COD3;
      windingCONT:=StrToInt(ata.CONT3);
    end;
  end;

  case windingCOD of
  0: ;  // SIN CONTROL DE TENSION EN EL NODO "winding"
  1:
    begin
      // CONTROL DE TENSION EN EL NODO "winding"
      NRegulador := ata.I;
      Barra_REGULADOR  := ata.Barra_I;
      if windingCONT = 0 then
      begin
         NRegulado := ata.J;
         Barra_REGULADA  := ata.Barra_J;
      end
      else
      begin
         NRegulado := windingCONT;
         Barra_REGULADA := sala.I_to_TodasLasBarras(nil, NRegulado);
      end;
      if (Barra_REGULADA.conectada) and (Barra_REGULADOR.conectada) then
      begin
        if TRaw_Bus(sala.Barras[Barra_REGULADOR.jcol - 1]).IDE <> 2 then
        begin
          sala.nodos_reguladores.Add(NRegulador);
          sala.nodos_regulados.Add(NRegulado);
          sala.trafos_reguladores.add(ata);
          TRaw_Bus(sala.Barras[Barra_REGULADOR.jcol - 1]).IDE := 2;
          inc(j);
        end;
      end
      else
        raise Exception.Create(
          'flujoraw.cargar_taps. Se está tratando de regular una barra desconectada: ' +
          IntToStr(NRegulador) + ', ' + IntToStr(NRegulado));
    end;
  2:
    begin
        // CONTROL DE Q EN EL NODO "winding"
      raise Exception.Create(
      'flujoraw.cargar_taps. No se implemento la regulacion de tipo 2: ' +
      IntToStr(ata.I) + ', ' + IntToStr(ata.j)+ ',' + IntToStr(ata.K));
    end;
  3:
    begin
        // CONTROL DE P EN EL NODO "winding"
      raise Exception.Create(
      'flujoraw.cargar_taps. No se implemento la regulacion de tipo 3: ' +
      IntToStr(ata.I) + ', ' + IntToStr(ata.j)+ ',' + IntToStr(ata.K));
    end;
  4:
    begin
        // CONTROL EN LINEAS DE DC EN EL NODO "winding"
      raise Exception.Create(
      'flujoraw.cargar_taps. No se implemento la regulacion de tipo 4: ' +
      IntToStr(ata.I) + ', ' + IntToStr(ata.j)+ ',' + IntToStr(ata.K));
    end;
  end;

end;

function RevisarSala(sala: TSalaFlucar): Boolean;
var
  kLinea, kbarra, MonoBarraConect, kIndice, BiBarraConect,
    TriBarraConect, jbarra: Integer;
  barratemp, BI, BJ: TRaw_Bus;
  suma: NComplex;
  es_la_K: Boolean;

begin
  Result:=TRUE;

  //Chequeo de las lineas activas no conecten nodos activos a diferente tension
  for kLinea:=0 to sala.Lineas.count-1 do
  begin
    if TRaw_Branch(sala.Lineas[kLinea]).ST=0 then
       Continue;
    BI:=sala.I_to_TodasLasBarras(nil,TRaw_Branch(sala.Lineas[kLinea]).I);
    BJ:=sala.I_to_TodasLasBarras(nil,TRaw_Branch(sala.Lineas[kLinea]).J);
    if IntToBool(TRaw_Branch(sala.Lineas[kLinea]).ST) then
      if (BI.IDE<>4) and (BJ.IDE<>4) and (BI.BASKV<>BJ.BASKV) then
      begin
         writeln('Una linea conecta los nodos ' + IntToStr(BI.I) +
                 ' y '+ IntToStr(BJ.I) +' que tienen diferente tensión');
         Result:=FALSE;
      end;
  end;
  for kLinea:=0 to sala.LineasImpCero.count-1 do
  begin
    if TRaw_Branch(sala.LineasImpCero[kLinea]).ST=0 then
       Continue;
    BI:=sala.I_to_TodasLasBarras(nil,TRaw_Branch(sala.LineasImpCero[kLinea]).I);
    BJ:=sala.I_to_TodasLasBarras(nil,TRaw_Branch(sala.LineasImpCero[kLinea]).J);
    if IntToBool(TRaw_Branch(sala.LineasImpCero[kLinea]).ST) then
      if (BI.IDE<>4) and (BJ.IDE<>4) and (BI.BASKV<>BJ.BASKV) then
      begin
         writeln('Una linea conecta los nodos ' + IntToStr(BI.I) +
                 ' y '+ IntToStr(BJ.I) +' que tienen diferente tensión');
         Result:=FALSE;
      end;
  end;


  //Se recorren todas las barras activas para ver si estan conectadas a por lo
  //menos dos elementos
  for kbarra:=0 to sala.Barras.count-1 do
  begin
    barratemp:=TRaw_Bus(sala.Barras[kbarra]);
    if barratemp.IDE=4 then //No es necesario, los elementos de la lista Barras no son tipo 4
       continue;
    MonoBarraConect:=0;
    for kIndice:=0 to sala.Cargas.count-1 do
      if (TRaw_Load(sala.Cargas[kIndice]).STATUS=1) and
        (TRaw_Load(sala.Cargas[kIndice]).I=barratemp.I) then
      begin
          MonoBarraConect:=MonoBarraConect+1;
      end;

    for kIndice:=0 to sala.Generadores.count-1 do
      if (TRaw_Generator(sala.Generadores[kIndice]).STAT=1) and
        (TRaw_Generator(sala.Generadores[kIndice]).I=barratemp.I) then
      begin
          MonoBarraConect:=MonoBarraConect+1;
      end;

    for kIndice:=0 to sala.Shunts.count-1 do
      if (TRaw_SwitcheShunt(sala.Shunts[kIndice]).STAT=1) and
        (TRaw_SwitcheShunt(sala.Shunts[kIndice]).I=barratemp.I) then
      begin
          MonoBarraConect:=MonoBarraConect+1;
      end;

    for kIndice:=0 to sala.ShuntsFijos.count-1 do
      if (TRaw_FixedShunt(sala.ShuntsFijos[kIndice]).STATUS=1) and
        (TRaw_FixedShunt(sala.ShuntsFijos[kIndice]).I=barratemp.I) then
      begin
          MonoBarraConect:=MonoBarraConect+1;
      end;


    BiBarraConect:=0;
    for kIndice:=0 to sala.Lineas.count-1 do
      if (TRaw_Branch(sala.Lineas[kIndice]).ST=1) and
        ((TRaw_Branch(sala.Lineas[kIndice]).I=barratemp.I) or
        (TRaw_Branch(sala.Lineas[kIndice]).J=barratemp.I)) then
      begin
          BiBarraConect:=BiBarraConect+1;
      end;

    for kIndice:=0 to sala.TerminalesDC.count-1 do
      if (TRaw_TwoTerminal_DCLine(sala.TerminalesDC[kIndice]).MDC<>0) and
        ((TRaw_TwoTerminal_DCLine(sala.TerminalesDC[kIndice]).I=barratemp.I) or
        (TRaw_TwoTerminal_DCLine(sala.TerminalesDC[kIndice]).J=barratemp.I)) then
      begin
          BiBarraConect:=BiBarraConect+1;
      end;

    for kIndice:=0 to sala.VSC.count-1 do
      if (TRaw_VoltageSourceConverter_DCLine(sala.VSC[kIndice]).MDC<>0) and
        (TRaw_VoltageSourceConverter_DCLine(sala.VSC[kIndice]).I=barratemp.I) or
        (TRaw_VoltageSourceConverter_DCLine(sala.VSC[kIndice]).J=barratemp.I) then
      begin
          BiBarraConect:=BiBarraConect+1;
      end;

    for kIndice:=0 to sala.Facts.count-1 do
      if (TRaw_Facts(sala.Facts[kIndice]).MODE<>0) and
        (TRaw_Facts(sala.Facts[kIndice]).I=barratemp.I) or
        (TRaw_Facts(sala.Facts[kIndice]).J=barratemp.I) then
      begin
          BiBarraConect:=BiBarraConect+1;
      end;

    TriBarraConect:=0;
    es_la_K:=FALSE;
    for kIndice:=0 to sala.trafosadjust.count-1 do
      if (TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).STAT=1) and
        (TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).I=barratemp.I) or
        (TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).J=barratemp.I) or
        (TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).K=barratemp.I) then
      begin
         TriBarraConect:=TriBarraConect+1;
         if (TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).STAT=1) and
            (TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).K=barratemp.I) then
            es_la_K:=TRUE;
      end;

    if (MonoBarraConect+BiBarraConect=0) and (TriBarraConect=1) and es_la_K then
       writeln('La barra ' + IntToStr(TRaw_Bus(sala.Barras[kbarra]).I) +
       ' se conecta solo a un bobinado K de un trafo');

    if not(BiBarraConect+TriBarraConect>1) then
       if not(MonoBarraConect+BiBarraConect+TriBarraConect>1) then
       begin
          writeln('La barra ' + IntToStr(TRaw_Bus(sala.Barras[kbarra]).I) +
          ' tiene: MonoBarras: ' + IntToStr(MonoBarraConect) +
          ' BiBarras: ' + IntToStr(BiBarraConect) +
          ' TriBarras: ' + IntToStr(TriBarraConect) + ' conectados.');
          Result:=FALSE;
       end;
  end;

  //Se chequea que no hayan barras aisladas
  for kbarra:=0 to sala.Barras.count-1 do
  begin
    suma := complex_NULO;
    for jbarra:=0 to sala.Barras.count-1 do
    begin
      suma.r:= suma.r + abs(sala.MY.e(kbarra+1,jbarra+1).r);
      suma.i:= suma.i + abs(sala.MY.e(kbarra+1,jbarra+1).i);
    end;
    if ((suma.r=0) and (suma.i=0)) then
    begin
      writeln('La barra ' + IntToStr(TRaw_Bus(sala.Barras[kbarra]).I) +' esta aislada');
      Result:=FALSE;
    end;
  end;

end;

function conectividad(var MatAdmitancias: TMatrizDeAdmitancias;
  var lugar: integer): boolean;
var
  i, n, k: integer;
  resultado: NComplex;
  arbol: array of boolean;
begin
  n := MatAdmitancias.numeroDeEcuaciones;
  setlength(arbol, n + 1);
  Result := True;
  lugar := 1;
  resultado := complex_NULO;
  for i := 1 to n do
    arbol[i] := False;

  for i := 1 to n do
    for k := 1 to n do
    begin
      if i <> k then
      begin
        if MatAdmitancias.ValCoef(resultado, i, k) and not
          EsCero(resultado) then
        begin
          arbol[k] := True;
        end;
      end;
    end;
  for i := 1 to n do
  begin
    writeln(arbol[i]);
    if not arbol[i] then
    begin
      Result := False;
      lugar := i;
    end;
  end;

end;



procedure dump_barras_to_txt(sala: TSalaFlucar; archi: string);
var
  f: textfile;
  i: integer;
  ab: TRaw_Bus;
begin
  assignfile(f, archi);
  rewrite(f);
  writeln(f, 'NBarras: ', #9, sala.Barras.Count);
  writeln(f, 'Name', #9, 'AREA', #9, 'I', #9, 'IDE', #9, 'IMP Cero');
  for i := 0 to sala.Barras.Count - 1 do
  begin
    ab := sala.Barras[i];
    writeln(f, ab.Name, #9, ab.AREA, #9, ab.I, #9, ab.IDE, #9, ab.IMP_CERO);
  end;
  closefile(f);
end;



procedure dump_cargas_to_txt(sala: TSalaFlucar; archi: string);
var
  f: textfile;
  i: integer;
  a: TRaw_Load;
begin
  assignfile(f, archi);
  rewrite(f);
  writeln(f, 'NCargas: ', #9, sala.Cargas.Count);
  writeln(f, 'ID', #9, 'AREA', #9, 'I', #9, 'PL', #9, 'QL');
  for i := 0 to sala.Cargas.Count - 1 do
  begin
    a := sala.Cargas[i];
    writeln(f, a.ID, #9, a.AREA, #9, a.I, #9, a.PL, #9, a.QL);
  end;
  closefile(f);
end;

procedure dump_MY_to_txt(sala: TSalaFlucar; archi: string);
var
  f: textfile;
  i, j: integer;
  a: NComplex;
  ab1, ab2: TRaw_Bus;
begin
  assignfile(f, archi);
  rewrite(f);
  //writeln( f, 'NCargas: ',#9, sala.Cargas.Count );
  //writeln( f, 'ID', #9, 'AREA', #9,  'I' );
  for i := 1 to sala.Barras.Count do
  begin
    for j := 1 to sala.Barras.Count do
    begin
      ab1 := sala.Barras[i - 1];
      ab2 := sala.Barras[j - 1];
      a := sala.MY.e(i, j);
      writeln(f, a.r, #9, a.i, #9); //ab1.I, #9,ab2.I, #9
    end;
    //writeln(f,' ');
  end;
  closefile(f);
end;

procedure EscribirRaw(sala: TSalaFlucar; archi: string);
var
  kIndice, k, nodo, desde, hasta: Integer;
  NOmbreArch, extensionent, NombreArchent: string;
  Texto, Grafos: TextFile;
  Nodes, Sources, Targets: TDAofString;

begin
  uauxiliares.setSeparadoresGlobales;

  k := pos('.', archi);
  NOmbreArch := copy(archi, 1, k - 1);
  extensionent := '.raw';
  NombreArchent := NombreArch + '_proc' + extensionent;

  Assign(Texto, NombreArchent);
  Rewrite(Texto);

  Assign(Grafos, NOmbreArch+'_grafos.csv');
  Rewrite(Grafos);
  SetLength(Nodes, sala.Barras.count + sala.TrafosAdjust.Count);
  SetLength(Sources, sala.Lineas.Count + sala.TerminalesDC.Count + sala.VSC.Count +
                     sala.Facts.Count + 2*sala.TrafosAdjust.Count);
  SetLength(Targets, sala.Lineas.Count + sala.TerminalesDC.Count + sala.VSC.Count +
                     sala.Facts.Count + 2*sala.TrafosAdjust.Count);
  nodo:=0;
  desde:=0;
  hasta:=0;

  //1 Se escribe el encabezado que está en el caso
  TRaw_CaseIdentification(sala.caso[0]).WriteToText(Texto);

  //2 Se escriben las Barras
  for kIndice:=0 to sala.Barras.count-1 do
  begin
    TRaw_Bus(sala.Barras[kIndice]).WriteToText(Texto);
    Nodes[nodo]:=IntToStr(TRaw_Bus(sala.Barras[kIndice]).I);
    inc(nodo);
  end;

  writeln(Texto,'0 / END OF BUS DATA, BEGIN LOAD DATA');
  // 3 Se escriben las cargas
  for kIndice:=0 to sala.Cargas.count-1 do
  begin
    TRaw_Load(sala.Cargas[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF LOAD DATA, BEGIN FIXED SHUNT DATA');
  //4 Se escriben Fixed Shunt
  for kIndice:=0 to sala.ShuntsFijos.count-1 do
  begin
    TRaw_FixedShunt(sala.ShuntsFijos[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF FIXED SHUNT DATA, BEGIN GENERATOR DATA');
  //5 Se escriben los Generdores
  for kIndice:=0 to sala.Generadores.count-1 do
  begin
    TRaw_Generator(sala.Generadores[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF GENERATOR DATA, BEGIN BRANCH DATA');
  // 6 Se escriben las lineas
  for kIndice:=0 to sala.Lineas.count-1 do
  begin
    TRaw_Branch(sala.Lineas[kIndice]).WriteToText(Texto);
    Sources[desde]:=IntToStr(TRaw_Branch(sala.Lineas[kIndice]).I);
    Targets[hasta]:=IntToStr(TRaw_Branch(sala.Lineas[kIndice]).J);
    inc(desde);
    inc(hasta);
  end;

  writeln(Texto,'0 / END OF BRANCH DATA, BEGIN TRANSFORMER DATA');
  // 7 Se escriben los transformadores
  for kIndice:=0 to sala.trafosadjust.count-1 do
  begin
    TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).WriteToText(Texto);
    Nodes[nodo]:='500' + IntToStr(kIndice);
    inc(nodo);

    Sources[desde]:=IntToStr(TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).I);
    Targets[hasta]:=Nodes[nodo-1];
    inc(desde);
    inc(hasta);
    Sources[desde]:=IntToStr(TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).J);
    Targets[hasta]:=Nodes[nodo-1];
    inc(desde);
    inc(hasta);
    if TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).K<>0 then
    begin
      SetLength(Sources, Length(Sources)+1);
      SetLength(Targets, Length(Targets)+1);
      Sources[desde]:=IntToStr(TRaw_TransformerAdjust(sala.trafosadjust[kIndice]).K);
      Targets[hasta]:=Nodes[nodo-1];
      inc(desde);
      inc(hasta);
    end;

  end;

  writeln(Texto,'0 / END OF TRANSFORMER DATA, BEGIN AREA DATA');
  // 8 Se escriben las areas
  for kIndice:=0 to sala.areas.count-1 do
  begin
    TRaw_AreaInterchange(sala.areas[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF AREA DATA, BEGIN TWO-TERMINAL DC DATA');
  // 9 Se escriben los two-terminal
  for kIndice:=0 to sala.TerminalesDC.count-1 do
  begin
    TRaw_TwoTerminal_DCLine(sala.TerminalesDC[kIndice]).WriteToText(Texto);
    Sources[desde]:=IntToStr(TRaw_TwoTerminal_DCLine(sala.TerminalesDC[kIndice]).I);
    Targets[hasta]:=IntToStr(TRaw_TwoTerminal_DCLine(sala.TerminalesDC[kIndice]).J);
    inc(desde);
    inc(hasta);
  end;

  writeln(Texto,'0 / END OF TWO-TERMINAL DC DATA, BEGIN VSC DC LINE DATA');
  // 10 Se escriben los VSC.
  for kIndice:=0 to sala.VSC.count-1 do
  begin
    TRaw_VoltageSourceConverter_DCLine(sala.VSC[kIndice]).WriteToText(Texto);
    Sources[desde]:=IntToStr(TRaw_VoltageSourceConverter_DCLine(sala.VSC[kIndice]).I);
    Targets[hasta]:=IntToStr(TRaw_VoltageSourceConverter_DCLine(sala.VSC[kIndice]).J);
    inc(desde);
    inc(hasta);
  end;

  writeln(Texto,'0 / END OF VSC DC LINE DATA, BEGIN IMPEDANCE CORRECTION DATA');
  // 11 Se escriben las Tablas de Correccion de impedancia.
  for kIndice:=0 to sala.ICTRATables.count-1 do
  begin
    TRaw_TransformerImpedanceCorrectionTables(sala.ICTRATables[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF IMPEDANCE CORRECTION DATA, BEGIN MULTI-TERMINAL DC DATA');
  // 12 Se escriben los Multi-Terminal.
  for kIndice:=0 to sala.TerminalesDCMult.count-1 do
  begin
    TRaw_MultiTerminal_DCLine(sala.TerminalesDCMult[kIndice]).WriteToText(Texto);
  end;

 writeln(Texto,'0 / END OF MULTI-TERMINAL DC DATA, BEGIN MULTI-SECTION LINE DATA');
  // 13 Se escriben las Multi Section Line.
  for kIndice:=0 to sala.LineasSeccion.count-1 do
  begin
    TRaw_MultiSectionLineGrouping(sala.LineasSeccion[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF MULTI-SECTION LINE DATA, BEGIN ZONE DATA');
  // 14 Se escriben las Zonas.
  for kIndice:=0 to sala.zonas.count-1 do
  begin
    TRaw_Zone(sala.zonas[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF ZONE DATA, BEGIN INTER-AREA TRANSFER DATA');
  // 15 Se escriben las Inter-Area de transferencia.
  for kIndice:=0 to sala.transfareas.count-1 do
  begin
    TRaw_InterAreaTransfer(sala.transfareas[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF INTER-AREA TRANSFER DATA, BEGIN OWNER DATA');
  // 16 Se escriben los Owners.
  for kIndice:=0 to sala.owners.count-1 do
  begin
    TRaw_Owner(sala.owners[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF OWNER DATA, BEGIN FACTS DEVICE DATA');
  // 17 Se escriben los Facts Device.
  for kIndice:=0 to sala.facts.count-1 do
  begin
    TRaw_Facts(sala.facts[kIndice]).WriteToText(Texto);
    Sources[desde]:=IntToStr(TRaw_Facts(sala.facts[kIndice]).I);
    Targets[hasta]:=IntToStr(TRaw_Facts(sala.facts[kIndice]).J);
    inc(desde);
    inc(hasta);
  end;

  writeln(Texto,'0 / END OF FACTS DEVICE DATA, BEGIN SWITCHED SHUNT DATA');
  // 18 Se escriben los Switched Shunt.
  for kIndice:=0 to sala.Shunts.count-1 do
  begin
    TRaw_SwitcheShunt(sala.Shunts[kIndice]).WriteToText(Texto);
  end;

  writeln(Texto,'0 / END OF SWITCHED SHUNT DATA, BEGIN GNE DATA');
  // 19 Se escriben los GNE

  writeln(Texto,'0 / END OF GNE DATA');
  writeln(Texto,'Q');


  CloseFile(Texto);
  ///////////////////////////////////////////////////////////////////////////
  for kIndice:=0 to Length(Nodes)-1 do
  begin
    write(Grafos,Nodes[kIndice]);
    if (kIndice<>Length(Nodes)-1) then
       write(Grafos,',')
    else
        writeln(Grafos);
  end;

  for kIndice:=0 to Length(Sources)-1 do
  begin
    write(Grafos,Sources[kIndice]);
    if (kIndice<>Length(Sources)-1) then
       write(Grafos,',')
    else
        writeln(Grafos);
  end;

  for kIndice:=0 to Length(Targets)-1 do
  begin
    write(Grafos,Targets[kIndice]);
    if (kIndice<>Length(Targets)-1) then
       write(Grafos,',')
    else
        writeln(Grafos);
  end;


  CloseFile(Grafos);
  /////////////////////////////////////////////////////////////////////////////
end;

procedure Preparar_sistema(sala: TSalaFlucar);
var
  i: integer;
begin

  //dump_barras_to_txt( sala, 'lst_barras1.xlt' );
  //dump_cargas_to_txt(sala,  'lst_cargas.xlt' );
  //dump_MY_to_txt(sala,  'sistema2.xlt' );

  //Barras
  for i := 0 to sala.Barras.Count - 1 do
  begin
    TRaw_Bus(sala.Barras[i]).cargue;
  end;

  //ShuntFijos
  if RAW_VER >= 32 then
  begin
    for i := 0 to sala.ShuntsFijos.Count - 1 do
    begin
      TRaw_FixedShunt(sala.ShuntsFijos[i]).cargue;
    end;
  end;

  //Lineas
  for i := 0 to sala.lineas.Count - 1 do
  begin
    TRaw_Branch(sala.lineas[i]).cargue;
  end;

  //TrafosAdjust
  if RAW_VER >= 32 then
  begin
    for i := 0 to sala.trafosAdjust.Count - 1 do
    begin
      TRaw_TransformerAdjust(sala.trafosAdjust[i]).cargue;
    end;
  end;

  //ShuntSwitched
  for i := 0 to sala.shunts.Count - 1 do
  begin
    TRaw_SwitcheShunt(sala.shunts[i]).cargue;
  end;

  //Cargas
  for i := 0 to sala.Cargas.Count - 1 do
  begin
    TRaw_Load(sala.Cargas[i]).cargue;
  end;

  //Generadores
  for i := 0 to sala.generadores.Count - 1 do
  begin
    TRaw_Generator(sala.generadores[i]).cargue;
  end;

  //TerminalesDC
  for i:=0 to sala.TerminalesDC.Count - 1 do
  begin
    TRaw_TwoTerminal_DCLine(sala.TerminalesDC[i]).cargue;
  end;

  //VoltageSourceConverterDCLine
  for i:=0 to sala.VSC.Count - 1 do
  begin
    TRaw_VoltageSourceConverter_DCLine(sala.VSC[i]).cargue;
  end;

end;

procedure cargar_taps(sala: TSalaFlucar);
var
  i, j: integer;
  ata: TRaw_TransformerAdjust;
begin
  j := 0;
  for i := 0 to sala.trafosAdjust.Count - 1 do
  begin
    ata := sala.trafosAdjust[i];
    //ata.resolver_referencias;

    if (ata.STAT = 1) then     // EN SERVICIO
    begin
       cargar_tap_winding(1, ata, j, sala);
       if (ata.K <> 0) then         // TRES BOBINADOS
       begin
         cargar_tap_winding(2, ata, j, sala);
         cargar_tap_winding(3, ata, j, sala);
       end;
    end
    else if (ata.STAT=2) or (ata.STAT=3) then
           raise Exception.Create(
              'Trafo con bobinado 2 o 3 desconectado:' +
              IntToStr(ata.I) + ', ' + IntToStr(ata.j)+ ',' + IntToStr(ata.K));
  end;
  writeln('ESTO ES EL FIN DE CARGAR LOS REGULADORES');
  writeln('Numero de reguladores ', j);

end;

procedure Cargar_problema(sala: TSalaFlucar);
var

  iEcuacion, Nudos, kkvar: integer;
  resOk, reg2, reg1, reg3: boolean;
  err: NReal;
  cntiters, i, h: integer;
  S_12, S_21, S_CON, I_I: NComplex;
  libres, nolibres, g, jtrafo: integer;
  ata: TRaw_TransformerAdjust;
  RMI_min, RMA_max: Double;
begin

  ufunciones_flucar.salaActiva := sala;

  Nudos := sala.nNodos;
  libres := 0;
  nolibres := 0;
  g := 0;

  for iEcuacion := 1 to Nudos do
  begin
    sala.problemaCPX.InscribirEcuacion(fi, iEcuacion);
    //writeln( 'fi'+IntToStr( inodo )+': '+FloatToStrF( res.r, ffFixed, 8,2 )+'+j'+FloatToStrF( res.i, ffFixed, 8,2 ),' abs ', mod1(res):8:0 );
  end;

  for iEcuacion := 1 to Nudos do
  begin
    case TRaw_Bus(sala.Barras[(iEcuacion - 1)]).IDE of
      1:     // BusType 1: load bus (no generator boundary condition)
      begin  // barra PQ o de carga
        sala.ProblemaCPX.DefinirVariable(iEcuacion, CPX_POLAR,
          0.5, 1.5, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM, False,
          -1.6, +1.6, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA / 180.0 * pi, False);

        sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL / 100, True,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL / 100, True);

        libres := libres + 2;
        nolibres := nolibres + 2;

        //writeln('nodo tipo 1 I ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I, ' ', g);
        //writeln('nodo tipo 1 NAME ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).NAME, ' ', g);
        //writeln('nodo tipo 1 v ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM);
        //writeln('nodo tipo 1 arg ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA);
        //writeln('nodo tipo 1 PL', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL);
        //writeln('nodo tipo 1 QL', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL);

      end;

      2:      //         2: generator or plan bus (either voltage regulator or fixed MVAR)
      begin // barra PV o de generacion o voltaje controlado
        sala.ProblemaCPX.DefinirVariable(iEcuacion, CPX_POLAR,
          0.5, 1.5, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM, True,
          -1.6, +1.6, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA / 180.0 * pi, False);
        libres := libres + 1;
        nolibres := nolibres + 1;
        if (sala.nodos_reguladores.Find(TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) > -1) then
        begin
          sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL / 100, True,
            //dejar fijos P, Q y variar tm (abajo)
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL / 100, True);
          nolibres := nolibres + 2;

          if sala.TapsVariables then
          begin
            ////////////////////////////////////////////////////////////////////
            {sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos + Nudos, CPX_POLAR,
              0.5, 1.5, 1.00, False,
              //agregar variable tm
              0, 1, 0, True);
            }

            for jtrafo:=0 to sala.trafos_reguladores.count-1 do
            begin
              ata := TRaw_TransformerAdjust(sala.trafos_reguladores[jtrafo]);
              reg1 := ( ata.I = TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) and ( ata.COD1 = 1 );

              reg2 := ( ata.J = TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) and ( ata.COD2 = 1 );

              reg3 := ( ata.K = TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) and ( ata.COD3 = 1 );

              if (reg1) then
              begin
                RMI_min := min(RMI_min,ata.RMI1);
                RMA_max := max(RMA_max,ata.RMA1);
              end;

              if (reg2) then
              begin
                RMI_min := min(RMI_min,ata.RMI2);
                RMA_max := max(RMA_max,ata.RMA2);
              end;

              if (reg3) then
              begin
                RMI_min := min(RMI_min,ata.RMI3);
                RMA_max := max(RMA_max,ata.RMA3);
              end;

            end;

            sala.ProblemaCPX.DefinirVariable(iEcuacion + 2 * Nudos, CPX_POLAR,
                  RMI_min, RMA_max, 1.00, False, 0, 0, 0, True);

            libres := libres + 1;
            nolibres := nolibres + 1;
            ////////////////////////////////////////////////////////////////////
          end;
        end
        else
        begin
          sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
            1, 1, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL / 100, True,
            //dejar fijo P y variar Q
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMIN / 100,
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMAX / 100,
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL / 100, False);

          //writeln('la generacion de la maquina es ',TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL: 6: 6 , ' MW');
          //writeln('la max reactiva de la maquina es ',TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMAX: 6: 6 , ' MVA');
          //writeln('la min reactiva de la maquina es ',TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMIN: 6: 6 , ' MVA');
          libres := libres + 1;
          nolibres := nolibres + 1;
        end;
        g := g + 1;
        writeln('nodo tipo 2, I=', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I, ' ', g);
        //writeln('nodo tipo 2 NAME ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).NAME, ' ', g);
        //writeln('nodo tipo 2 v ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM);
        //writeln('nodo tipo 2 arg ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA);
        writeln('nodo tipo 2 PL ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL);
        writeln('nodo tipo 2 QL ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL);
        writeln('nodo tipo 2 QMIN ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMIN);
        writeln('nodo tipo 2 QMAX ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMAX);

      end;

      3:    //         3: swing bus
      begin  // barra Slack (Flotante)
        sala.ProblemaCPX.DefinirVariable(iEcuacion, CPX_POLAR,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM, True,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA / 180.0 * pi, True);

        sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
          -9999, 9999, -75, False, -9999, 9999, -30, False);

        libres := libres + 2;
        nolibres := nolibres + 2;

        writeln('nodo tipo 3, I=', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I, ' ', g);
        //writeln('nodo tipo 3 NAME ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).NAME, ' ', g);
        writeln('nodo tipo 3 v ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM);
        writeln('nodo tipo 3 arg ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA);
        writeln('nodo tipo 3 PL', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL);
        writeln('nodo tipo 3 QL', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL);
      end;
      4:   //         4: disconnected (isolated ) bus
      begin
        // nada
      end;
    end;



    ////si el nodo es regulador, agregar tm variable, de lo contrario agregar un tm fijo
    if sala.TapsVariables then
    begin
      if (sala.nodos_reguladores.Find(TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) > -1) then
      begin
        //Ya se fue haciendo segun el IDE de la Barra, por lo que no se debe hacer de nuevo
        {sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos + Nudos, CPX_POLAR,
          0.5,  1.5,  TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM, false,
          -1.6,  1.6,  TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA/180*pi, false);

        writeln('Nodo ' + IntToStr( TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) + ' es regulador.');
        writeln('ESTO NO ESTA PROBADO!');
        libres:= libres + 2;  }
      end
      else
      begin
        sala.ProblemaCPX.DefinirVariable(iEcuacion + 2 * Nudos, CPX_POLAR,
          1, 1, 1, True, 0, 0, 0, True);
        nolibres := nolibres + 2;
      end;
    end
    else
    begin
      // cargo tm fijo
      {$IFDEF TM_FIJO}
      sala.ProblemaCPX.DefinirVariable(iEcuacion + 2 * Nudos, CPX_POLAR,
        1, True, 0, True);
      nolibres := nolibres + 2;
      {$ENDIF}
    end;


    //writeln('libres ', libres, '   no libres  ', nolibres);
  end;

  for iEcuacion := 1 to Nudos do
    for kkvar := 1 to Nudos do
    begin
      sala.ProblemaCPX.InscribirDerivada(dfidro_V, iEcuacion, kkvar, 1);
      sala.ProblemaCPX.InscribirDerivada(dfidalfa_V, iEcuacion, kkvar, 2);
      sala.ProblemaCPX.InscribirDerivada(dfidP, iEcuacion, kkvar + Nudos, 1);
      sala.ProblemaCPX.InscribirDerivada(dfidQ, iEcuacion, kkvar + Nudos, 2);
      if sala.TapsVariables then
      begin
        sala.ProblemaCPX.InscribirDerivada(dfidtm, iEcuacion,
          kkvar + 2 * Nudos, 1);
        sala.ProblemaCPX.InscribirDerivada(dfidargtm, iEcuacion,
          kkvar + 2 * Nudos, 2);
      end;
    end;


  writeln('Variables Libres  ', libres);
  writeln('Variables NO Libres  ', nolibres);
  //sala.MY.writetoTXT('sistema.xlt');

  // dump_MY_to_txt(sala,  'sistema2.xlt' );
  //readln;


  resOk := sala.ProblemaCPX.BuscarSolucion_NewtonRapson(1e-3, 1000, err, cntiters);
  //readln;
  if not resOK then
  begin
    writeln('No CONVERGIO ' + sala.ProblemaCPX.errMsg);
    writeln('.... PRESIONE ENTER PARA CONTINUAR....');
    system.readln;
    for iEcuacion := 1 to Nudos do
    begin
      Writeln('nudo ', iEcuacion, '   ');
      writeln('|V|= ', mod1(sala.ProblemaCPX.zvalores.v[iEcuacion]): 6: 6);
      writeln('arg(V)= ', fase(sala.ProblemaCPX.zvalores.v[iEcuacion]) *
        180.0 / pi: 6: 6);
      //writeln(p.zvalores.v[iEcuacion].r: 6:6);
      //writeln(p.zvalores.v[iEcuacion].i: 6:6);

      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM :=
        mod1(sala.ProblemaCPX.zvalores.v[iEcuacion]);
      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA :=
        fase(sala.ProblemaCPX.zvalores.v[iEcuacion]);
      writeln('P= ', sala.ProblemaCPX.zvalores.v[iEcuacion + Nudos].r * 100: 6: 6);
      writeln('Q= ', sala.ProblemaCPX.zvalores.v[iEcuacion + Nudos].i * 100: 6: 6);
      if sala.TapsVariables then
      begin
        writeln('tm= ', 1 / sala.ProblemaCPX.zvalores.v[iEcuacion + 2 * Nudos].r: 6: 6);
        writeln('Im(tm)= ', sala.ProblemaCPX.zvalores.v[iEcuacion + 2 * Nudos].i: 6: 6);
      end;
    end;
    writeln('Nro de iteraciones  ', cntiters);
  end
  else
  begin
    writeln(' FELICITACIONES CONVERGIO ' + sala.ProblemaCPX.errMsg);
    //readln;
    for iEcuacion := 1 to Nudos do
    begin
      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM :=
        mod1(sala.ProblemaCPX.zvalores.v[iEcuacion]);
      //*TRaw_Bus(sala.Barras[(iEcuacion - 1)]).BASKV;
      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA :=
        fase(sala.ProblemaCPX.zvalores.v[iEcuacion]) * 180.0 / pi;

      Writeln('nudo ', iecuacion, '  N: ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I,
        ' ', TRaw_Bus(sala.Barras[(iEcuacion - 1)]).Name, ' ',
        '|V|= ', mod1(sala.ProblemaCPX.zvalores.v[iEcuacion]): 3: 3, ' < ',
        fase(sala.ProblemaCPX.zvalores.v[iEcuacion]) * 180.0 / pi: 6: 6, ' ',
        'P= ', sala.ProblemaCPX.zvalores.v[iEcuacion + Nudos].r *
        100: 3: 3, ' Q= ', sala.ProblemaCPX.zvalores.v[iEcuacion + Nudos].i * 100: 3: 3);


      if not (sala.nodos_reguladores.IntCount = 0) then
      begin
        writeln('tm= ', 1 / sala.ProblemaCPX.zvalores.v[iEcuacion + 2 * Nudos].r:
          4: 4, ' < ', sala.ProblemaCPX.zvalores.v[iEcuacion + 2 * Nudos].i: 4: 4);
      end;

    end;
    //readln;
    writeln('Nro de iteraciones  ', cntiters);
    writeln('');
    for i := 0 to sala.lineas.Count - 1 do
    begin
      if (sala.nodos_reguladores.Find(TRaw_Branch(sala.lineas[i]).I) > -1) then
      begin
        h := TRaw_Branch(sala.lineas[i]).Barra_I.jcol;
        TRaw_Branch(sala.lineas[i]).RATIO :=
          1 / (sala.ProblemaCPX.zvalores.v[h + 2 * Nudos].r);
        // TRaw_Branch(sala.lineas[i]).RATIO/(sala.ProblemaCPX.zvalores.v[h + 2 * Nudos].r);    //   1/sala.ProblemaCPX.zvalores.v[h + 2 * Nudos].r;
      end;


      TRaw_Branch(sala.lineas[i]).Calculo_potencias(S_12, S_21, S_CON, I_I);
      writeln(' linea ', TRaw_Branch(sala.lineas[i]).I, ' ',
        TRaw_Branch(sala.lineas[i]).J, '  ', ' P12 = ', S_12.r * 100: 6: 2,
        ' Q12 = ', S_12.i * 100: 6: 2, ' P21=', S_21.r * 100: 6: 2,
        ' Q21=', S_21.i * 100: 6: 2, ' PCON = ', S_CON.r * 100: 6: 2,
        ' QCON = ', S_CON.i * 100: 6: 2, ' ratio ',
        TRaw_Branch(sala.lineas[i]).RATIO: 6: 3);

    end;

  end;
  //sala.MY.muestrasistema;
end;

procedure Cargar_solo_problema(sala: TSalaFlucar);
var

  iEcuacion, Nudos, kkvar: integer;
  resOk: boolean;
  err, k: NReal;
  cntiters, i, h: integer;
  S_12, S_21, S_CON, I_I: NComplex;
  libres, nolibres: integer;
begin
  ufunciones_flucar.salaActiva := sala;
  Nudos := sala.nNodos;
  libres := 0;
  nolibres := 0;

  for iEcuacion := 1 to Nudos do
    sala.problemaCPX.InscribirEcuacion(fi, iEcuacion);

  for iEcuacion := 1 to Nudos do
  begin
    case TRaw_Bus(sala.Barras[(iEcuacion - 1)]).IDE of
      1:
      begin  // barra PQ o de carga

        sala.ProblemaCPX.DefinirVariable(iEcuacion, CPX_POLAR,
          0.5, 1.5, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM, False,
          -1.6, +1.6, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA / 180.0 * pi, False);

        sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL / 100, True,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL / 100, True);

        libres := libres + 2;
        nolibres := nolibres + 2;
      end;

      2:
      begin // barra PV o de generacion o voltaje controlado

        sala.ProblemaCPX.DefinirVariable(iEcuacion, CPX_POLAR,
          0.5, 1.5, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM, True,
          -1.6, +1.6, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA / 180.0 * pi, False);
        libres := libres + 1;
        nolibres := nolibres + 1;



        if (sala.nodos_reguladores.Find(TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) >
          -1) then
        begin
          sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL / 100, True,
            //dejar fijos P, Q y variar tm (abajo)
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL / 100, True);
          nolibres := nolibres + 2;


          sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos + Nudos, CPX_POLAR,
            0.5, 1.5, 1.00, False,
            //agregar variable tm
            0, 1, 0, True);
          libres := libres + 1;
          nolibres := nolibres + 1;

        end
        else
        begin
          sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
            1, 1, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL / 100, True,
            //dejar fijo P y variar Q
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMIN / 100,
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QMAX / 100,
            TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL / 100, False);
          libres := libres + 1;
          nolibres := nolibres + 1;
        end;

      end;

      3:
      begin  // barra Slack (Flotante)

        sala.ProblemaCPX.DefinirVariable(iEcuacion, CPX_POLAR,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM, True,
          TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA / 180.0 * pi, True);

        sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos, CPX_RECTANGULAR,
          -9999, 9999, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).PL,
          False, -9999, 9999, TRaw_Bus(sala.Barras[(iEcuacion - 1)]).QL, False);

        libres := libres + 2;
        nolibres := nolibres + 2;
      end;

    end;

    ////si el nodo es regulador, agregar tm variable, de lo contrario agregar un tm fijo
    if (sala.nodos_reguladores.Find(TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I) > -1) then
    begin
    end
    else
    begin
      if sala.TapsVariables then
        sala.ProblemaCPX.DefinirVariable(iEcuacion + Nudos + Nudos, CPX_POLAR,
          1, 1, 1, True,
          0, 0, 0, True);
      nolibres := nolibres + 2;

    end;

  end;

  //writeln('libres ', libres, '   no libres  ', nolibres);
  for iEcuacion := 1 to Nudos do
    for kkvar := 1 to Nudos do
    begin
      sala.ProblemaCPX.InscribirDerivada(dfidro_V, iEcuacion, kkvar, 1);
      sala.ProblemaCPX.InscribirDerivada(dfidalfa_V, iEcuacion, kkvar, 2);
      sala.ProblemaCPX.InscribirDerivada(dfidP, iEcuacion, kkvar + Nudos, 1);
      sala.ProblemaCPX.InscribirDerivada(dfidQ, iEcuacion, kkvar + Nudos, 2);
      if sala.TapsVariables then
      begin
        sala.ProblemaCPX.InscribirDerivada(dfidtm, iEcuacion, kkvar + 2 * Nudos, 1);
        sala.ProblemaCPX.InscribirDerivada(dfidargtm, iEcuacion,
          kkvar + 2 * Nudos, 2);
      end;
    end;
end;


procedure Cargar_datos_luego_de_resuelto(Convergio: boolean; sala: TSalaFlucar);
var

  iEcuacion, Nudos, kkvar: integer;
  err, k: NReal;
  cntiters, i, h: integer;
  S_12, S_21, S_CON, I_I: NComplex;

begin
  cntiters := 0;
  Nudos := sala.nNodos;
  if not Convergio then
  begin
    writeln('No CONVERGIO ' + sala.ProblemaCPX.errMsg);
    writeln('.... PRESINE ENTER PARA CONTINUAR....');
    system.readln;
    for iEcuacion := 1 to Nudos do
    begin
      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM :=
        mod1(sala.ProblemaCPX.zvalores.v[iEcuacion]);
      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA :=
        fase(sala.ProblemaCPX.zvalores.v[iEcuacion]);
    end;
    writeln('Nro de iteraciones  ', cntiters);
  end
  else
  begin
    //writeln(' FELICITACIONES CONVERGIO ' + sala.ProblemaCPX.errMsg);
    //readln;
    for iEcuacion := 1 to Nudos do
    begin
      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VM :=
        mod1(sala.ProblemaCPX.zvalores.v[iEcuacion]);
      //*TRaw_Bus(sala.Barras[(iEcuacion - 1)]).BASKV;
      TRaw_Bus(sala.Barras[(iEcuacion - 1)]).VA :=
        fase(sala.ProblemaCPX.zvalores.v[iEcuacion]) * 180.0 / pi;

      //Writeln('nudo ', iecuacion, '  N: ',TRaw_Bus(sala.Barras[(iEcuacion - 1)]).I, ' ',TRaw_Bus(sala.Barras[(iEcuacion - 1)]).NAME, ' ',
      //'|V|= ', mod1(sala.ProblemaCPX.zvalores.v[iEcuacion]): 3: 3,' < ', fase(sala.ProblemaCPX.zvalores.v[iEcuacion]) * 180.0 / pi: 6: 6, ' ',
      //'P= ', sala.ProblemaCPX.zvalores.v[iEcuacion + Nudos].r * 100: 3: 3,' Q= ', sala.ProblemaCPX.zvalores.v[iEcuacion + Nudos].i * 100: 3: 3);

      if not (sala.nodos_reguladores.IntCount = 0) then
      begin
        writeln('tm= ', 1 / sala.ProblemaCPX.zvalores.v[iEcuacion +
          2 * Nudos].r: 4: 4, ' < ', sala.ProblemaCPX.zvalores.v[iEcuacion +
          2 * Nudos].i: 4: 4);

      end;

    end;
    //readln;
    //writeln('Nro de iteraciones  ', cntiters);
    //writeln('');
    for i := 0 to sala.lineas.Count - 1 do
    begin
      if (sala.nodos_reguladores.Find(TRaw_Branch(sala.lineas[i]).I) > -1) then
      begin
        h := TRaw_Branch(sala.lineas[i]).Barra_I.jcol;
        TRaw_Branch(sala.lineas[i]).RATIO :=
          1 / (sala.ProblemaCPX.zvalores.v[h + 2 * Nudos].r);
        // TRaw_Branch(sala.lineas[i]).RATIO/(sala.ProblemaCPX.zvalores.v[h + 2 * Nudos].r);    //   1/sala.ProblemaCPX.zvalores.v[h + 2 * Nudos].r;
      end;
      TRaw_Branch(sala.lineas[i]).Calculo_potencias(S_12, S_21, S_CON, I_I);
    end;
  end;
end;

end.
